export declare class ManagedError extends Error {
    constructor();
}
export type ManagedErrorType<TManagedErrorTypeName extends string> = (typeof ManagedError & {
    readonly name: TManagedErrorTypeName;
    readonly namespace?: string;
});
export declare const declareManagedErrorType: () => {
    name: <TManagedErrorTypeName extends string>(managedErrorTypeName: TManagedErrorTypeName) => {
        namespace: (managedErrorTypeNamespace?: string) => { [ManagedErrorTypeName in TManagedErrorTypeName]: ManagedErrorType<TManagedErrorTypeName>; };
    };
};
export declare const getManagedErrorTypeFullname: (managedErrorType: ManagedErrorType<string>) => string;
export declare const getManagedErrorFullname: (managedError: ManagedError) => string;
//# sourceMappingURL=managed-error.d.ts.map